#include "matching_descent.h"
#include "machineReassignment.h"
/************************** RANDOM *********************/
#define MBIG    1000000000L
#define MSEED   161803398L
#define MZ              0

#define REPORT    0

void MatchingDescent::srand3(int g)
	{
	long mj, mk;
	int i, ii, k;
	mj=MSEED-g;
	mj %= MBIG;
	ma[55]=mj;
	mk=1;
	for (i=1; i<=54 ; i++) 
		{
		ii = (21 * i) % 55;
		ma[ii]=mk;
		mk=mj-mk;
		if (mk < MZ)
			mk += MBIG;
		mj=ma[ii];
		}
	for (k=1 ; k<=4 ; k++)
		for (i=1 ; i<=55 ; i++) 
			{
			ma[i] -= ma[1 + (i+30) % 55];
			if (ma[i] < MZ)
			ma[i] += MBIG;
			}
	inext=0;
	inextp=31;
	}
int MatchingDescent::rand3(void)
	{
	long mj;

	if (++inext == 56)
		inext=1;
	if (++inextp == 56)
		inextp=1;
	mj=ma[inext] - ma[inextp];
	if (mj < MZ)
		mj += MBIG;
	ma[inext]=mj;
	return mj;
	}
unsigned int MatchingDescent::fscan_next_ill(char *&pb)
	{
	int c;
	unsigned int v=0;
	c=*pb++;
	if (c>'0' && c<='9') v=c-'0';
	while(' '!=(c=*pb++)){if(c=='\n' || c=='\t') break;
	v=(10*v)+c-'0';}
	return v;
	}
int MatchingDescent::litjeu(const char *fic)
	{
// Ressources 
	unsigned int val;
// Poids Moves
 	int r,m,n,s,t,p,b;
// Lecture en un seul acces
	int nb_car;
	int fid;
	char *pb,*buffer;
	fid=_open(fic,_O_RDONLY | _O_TEXT | _O_SEQUENTIAL);
	nb_car=_filelength(fid);
	buffer=new char [nb_car];
	_read(fid,buffer,nb_car);
	_close(fid);
	pb=buffer;
/************************/
/* nombre de ressources */
/************************/
	nb_rs=fscan_next_ill(pb);		   
	nb_rsTr=0;
	is_TR=new char [nb_rs];
	weightLoadCost=new int [nb_rs];
/********************************/
/* lecture des nb_rs ressources */
/********************************/
	 for (r=0;r<nb_rs;r++)
		{
		val=fscan_next_ill(pb);
		weightLoadCost[r]=fscan_next_ill(pb);
		is_TR[r]=val;
		if (val!=0) nb_rsTr++;
		}
/**********************/
/* nombre de machines */
/**********************/
	nb_mc=fscan_next_ill(pb);
	mac=new machine[nb_mc];
	MMC=new int *[nb_mc];
	for (m=0;m<nb_mc;m++)
		{
		mac[m].cap=new long long int [nb_rs];
		mac[m].sfc=new long long int [nb_rs];
		mac[m].use=new long long int [nb_rs];
		mac[m].truse=new long long int [nb_rs];
		MMC[m]=new int [nb_mc];
		}
/******************************/
/* lecture des nb_mc machines */
/******************************/
	nb_lc=0;
	nb_nei=0;
	for (m=0;m<nb_mc;m++)
		{
		mac[m].nei=fscan_next_ill(pb);
		mac[m].loc=fscan_next_ill(pb);
		if (mac[m].loc>nb_lc) nb_lc=mac[m].loc;
		if (mac[m].nei>nb_nei) nb_nei=mac[m].nei;
		for (r=0;r<nb_rs;r++)
			{
			mac[m].cap[r]=fscan_next_ill(pb);
			mac[m].use[r]=0;
			mac[m].truse[r]=0;
			}
		for (r=0;r<nb_rs;r++)
			mac[m].sfc[r]=fscan_next_ill(pb);
		for (n=0;n<nb_mc;n++)
			MMC[m][n]=fscan_next_ill(pb);
		}
	nb_lc++;
	nb_nei++;
/**********************/
/* nombre de services */
/**********************/
	nb_sr=fscan_next_ill(pb); 
	ser=new service [nb_sr];
	sermov=new short [nb_sr];
	serloc=new int* [nb_sr];
	sernei=new int* [nb_sr];
	sermac=new char* [nb_sr];

/******************************/
/* lecture des nb_sr services */
/******************************/
	for (s=0;s<nb_sr;s++)
		{
		ser[s].spread=0;
		sermov[s]=0;
		serloc[s]=new int [nb_lc];
		sernei[s]=new int [nb_nei];
		sermac[s]=new char [nb_mc];
		for (t=0;t<nb_lc;t++)
			serloc[s][t]=0;
		for (t=0;t<nb_nei;t++)
			sernei[s][t]=0;
		for (t=0;t<nb_mc;t++)
			sermac[s][t]=0;
		ser[s].spreadMin=fscan_next_ill(pb); 
		ser[s].nb_maste=fscan_next_ill(pb); 
		ser[s].nb_slave=0;
		ser[s].master=new int [ser[s].nb_maste];
		for (t=0;t<ser[s].nb_maste;t++)
			ser[s].master[t]=fscan_next_ill(pb);
		}
	for (s=0;s<nb_sr;s++)
		for (t=0;t<ser[s].nb_maste;t++)
			ser[ser[s].master[t]].nb_slave++;
	for (s=0;s<nb_sr;s++)
		if (ser[s].nb_slave!=0) 
			{
			ser[s].slaves=new int [ser[s].nb_slave];
			ser[s].nb_slave=0;
			}
	for (s=0;s<nb_sr;s++)
		for (t=0;t<ser[s].nb_maste;t++)
			ser[ser[s].master[t]].slaves[ser[ser[s].master[t]].nb_slave++]=s;
  /***********************/
/* nombre de processus */
/***********************/
	nb_pr=fscan_next_ill(pb); 
	pro=new processus [nb_pr];	 
/*******************************/
/* lecture des nb_pr processus */
/*******************************/
	for (p=0;p<nb_pr;p++)
		{
		pro[p].numservice=fscan_next_ill(pb); 
		pro[p].req=new int [nb_rs];
		for (r=0;r<nb_rs;r++)
			pro[p].req[r]=fscan_next_ill(pb); 
		pro[p].movecost=fscan_next_ill(pb);
		}
  /******************/
/* nombre de baob */
/******************/
	nb_bo=fscan_next_ill(pb); 
	bao=new baob [nb_bo];	 
/**************************/
/* lecture des nb_bo baob */
/**************************/
	for (b=0;b<nb_bo;b++)
		{
		bao[b].res1=fscan_next_ill(pb);
		bao[b].res2=fscan_next_ill(pb);
		bao[b].target=fscan_next_ill(pb);
		bao[b].weight=fscan_next_ill(pb);
		}
  /**************************************************/
/* Lecture des 3 derniers coef de la fonction obj */
/**************************************************/
	weightPMCost=fscan_next_ill(pb);
	weightSMCost=fscan_next_ill(pb);
	weightMMCost=fscan_next_ill(pb);
  delete [] buffer;
	return 0;
	}
int MatchingDescent::litsolinit(const char *fic)
	{
	int p,m0p,r,s;
// Lecture en un seul acces
	int nb_car;
	int fid;
	char *pb,*buffer;
	fid=_open(fic,_O_RDONLY | _O_TEXT | _O_SEQUENTIAL);
	nb_car=_filelength(fid);
	buffer=new char [nb_car];
	_read(fid,buffer,nb_car);
	_close(fid);
	pb=buffer;
	x0=new short [nb_pr];
	x=new short [nb_pr];
/**********************************/
/* lecture des nb_pr affectations */
/**********************************/
	int k=0;
	for (p=0;p<nb_pr;p++)
		{
		pro[p].movecost=weightPMCost*pro[p].movecost;
		m0p=fscan_next_ill(pb);
		x0[p]=x[p]=m0p;
		s=pro[p].numservice;
		if (serloc[s][mac[m0p].loc]==0) ser[s].spread++;
		serloc[s][mac[m0p].loc]++;
		sernei[s][mac[m0p].nei]++;
		sermac[s][m0p]++;
		for (r=0;r<nb_rs;r++)
			mac[m0p].use[r]=mac[m0p].use[r]+pro[p].req[r];	
		pro[p].indep=(ser[s].nb_maste==0 && ser[s].nb_slave==0 && ser[s].spreadMin<2)?1:0;
		k=k+pro[p].indep;
		}
  delete [] buffer;
	return 0;
	}

void MatchingDescent::addPM(int p,short m)
	{
	int r,sp;
	sp=pro[p].numservice;
	sermac[sp][m]++;
	if (serloc[sp][mac[m].loc]==0) ser[sp].spread++;
	serloc[sp][mac[m].loc]++;
	sernei[sp][mac[m].nei]++;
	x[p]=m;
	if (m!=x0[p]) 
		{
		sermov[sp]++;
		sum_move=sum_move+MMC[x0[p]][m]+pro[p].movecost;
		if (sermov[sp]>service_move_max)
			{
			service_move_max++;
			nb_service_move_max=1;
			sum_move=sum_move+weightSMCost;
			}
		else
		if (sermov[sp]==service_move_max)
			nb_service_move_max++;
		for (r=0;r<nb_rs;r++)
			mac[m].use[r]=mac[m].use[r]+pro[p].req[r];
		return;
		}
	for (r=0;r<nb_rs;r++)
		{
		mac[m].use[r]=mac[m].use[r]+pro[p].req[r];
		if (is_TR[r]!=0) mac[m].truse[r]=mac[m].truse[r]-pro[p].req[r];
		}
	}
void MatchingDescent::suppPM(int p,short m)
	{
	int r,sp;
	sp=pro[p].numservice;
	sermac[sp][m]--;
	serloc[sp][mac[m].loc]--;
	if (serloc[sp][mac[m].loc]==0) ser[sp].spread--;
	sernei[sp][mac[m].nei]--;
	if (m!=x0[p]) 
		{
		sum_move=sum_move-(MMC[x0[p]][m]+pro[p].movecost);
		if (sermov[sp]==service_move_max)
			{
			nb_service_move_max--;
			if (nb_service_move_max==0) 
				{
				service_move_max--;
				sum_move=sum_move-weightSMCost;
				for (int s=0;s<nb_sr;s++)
					if (sermov[s]>=service_move_max) 
						nb_service_move_max++;
				}
			}
		sermov[sp]--;		
		for (r=0;r<nb_rs;r++)
			mac[m].use[r]=mac[m].use[r]-pro[p].req[r];
		return;
		}
	for (r=0;r<nb_rs;r++)
		{
		mac[m].use[r]=mac[m].use[r]-pro[p].req[r];
		if (is_TR[r]!=0) mac[m].truse[r]=mac[m].truse[r]+pro[p].req[r];
		}
	}
void MatchingDescent::addPM_(int p,short m)
	{
	int r;
	if (m!=x0[p]) 
		{
		sum_move=sum_move+MMC[x0[p]][m]+pro[p].movecost;
		for (r=0;r<nb_rs;r++)
			mac[m].use[r]=mac[m].use[r]+pro[p].req[r];
		return;
		}
	for (r=0;r<nb_rs;r++)
		{
		mac[m].use[r]=mac[m].use[r]+pro[p].req[r];
		if (is_TR[r]!=0) mac[m].truse[r]=mac[m].truse[r]-pro[p].req[r];
		}
	}
void MatchingDescent::suppPM_(int p,short m)
	{
	int r;
	if (m!=x0[p]) 
		{
		sum_move=sum_move-(MMC[x0[p]][m]+pro[p].movecost);
		for (r=0;r<nb_rs;r++)
			mac[m].use[r]=mac[m].use[r]-pro[p].req[r];
		return;
		}
	for (r=0;r<nb_rs;r++)
		{
		mac[m].use[r]=mac[m].use[r]-pro[p].req[r];
		if (is_TR[r]!=0) mac[m].truse[r]=mac[m].truse[r]+pro[p].req[r];
		}
	}
int MatchingDescent::load_PM(int p,short m,long long int &lc)
	{
	long long int delta,newuse;
	short r,r1,r2;
	lc=0;
	for (r=0;r<nb_rs;r++)
		{
		newuse=mac[m].use[r]+pro[p].req[r];
		if (newuse+mac[m].truse[r]>mac[m].cap[r]) return 0;	
		delta=newuse-mac[m].sfc[r];
		if (delta>0) 
			lc=lc+((long long int) weightLoadCost[r]*delta);
		}
	for (r=0;r<nb_bo;r++)
		{
		r1=bao[r].res1;
		r2=bao[r].res2;
		delta=bao[r].target*(mac[m].cap[r1]-(mac[m].use[r1]+pro[p].req[r1]));
		delta=delta-(mac[m].cap[r2]-(mac[m].use[r2]+pro[p].req[r2]));
		if (delta>0)
			lc=lc+(bao[r].weight*delta);
		}
	return -1;
	}
int MatchingDescent::load_PM0(int p,short m,long long int &lc)
	{
	long long int delta,newuse;
	short r,r1,r2;
	lc=0;
	for (r=0;r<nb_rs;r++)
		if (is_TR[r]!=0)
			{
			newuse=mac[m].use[r]+pro[p].req[r];
			delta=newuse-mac[m].sfc[r];
			if (delta>0) 
				lc=lc+((long long int) weightLoadCost[r]*delta);
			}
		else
			{
			newuse=mac[m].use[r]+pro[p].req[r];
			if (newuse+mac[m].truse[r]>mac[m].cap[r]) return 0;	
			delta=newuse-mac[m].sfc[r];
			if (delta>0) 
				lc=lc+((long long int) weightLoadCost[r]*delta);
			}
	for (r=0;r<nb_bo;r++)
		{
		r1=bao[r].res1;
		r2=bao[r].res2;
		delta=bao[r].target*(mac[m].cap[r1]-(mac[m].use[r1]+pro[p].req[r1]));
		delta=delta-(mac[m].cap[r2]-(mac[m].use[r2]+pro[p].req[r2]));
		if (delta>0)
			lc=lc+(bao[r].weight*delta);
		}
	return -1;
	}
void MatchingDescent::MWM(void)
	{
	int i;
	long long int poids;	
	sompoids[0]=0;
	match[0]=0;
	match[1]=1;
	sompoids[1]=gswap[machine1[0]][machine2[0]];
	for (i=2;i<=nba;i++)
		{
		poids=gswap[machine1[i-1]][machine2[i-1]];
		if (poids+sompoids[i-2]<sompoids[i-1])
			{
			sompoids[i]=poids+sompoids[i-2];
			match[i]=i;
			}
		else
			{
			sompoids[i]=sompoids[i-1];
			match[i]=match[i-1];
			}
		}
	}
void MatchingDescent::evalsuppPM(int p,short m,long long int &newlc)
	{
	long long int delta;
	short r,r1,r2;
	newlc=0;
	for (r=0;r<nb_rs;r++)
		{
		delta=mac[m].use[r]-(pro[p].req[r]+mac[m].sfc[r]);
		if (delta>0) newlc+=((long long int) weightLoadCost[r]*delta);
		}
	for (r=0;r<nb_bo;r++)
		{
		r1=bao[r].res1;
		r2=bao[r].res2;
		delta=bao[r].target*(mac[m].cap[r1]-(mac[m].use[r1]-pro[p].req[r1]));
		delta=delta-(mac[m].cap[r2]-(mac[m].use[r2]-pro[p].req[r2]));
		if (delta>0)
			newlc+=(bao[r].weight*delta);
		}
	}
int MatchingDescent::evalswapM1M2(short m1,short m2,long long int &delta)
	{
	long long int newlc,reste1,reste2;
	short r,r1,r2,m,m0;
	int p;
	newlc=0;
	for (r=0;r<nb_rs;r++)
		{				
		reste1=mac[m1].cap[r]-mac[m2].use[r];
		if (reste1<0) return 0;
		reste2=mac[m2].cap[r]-mac[m1].use[r];
		if (reste2<0) return 0;
		delta=mac[m1].use[r]-mac[m2].sfc[r];
		if (delta>0) newlc+=((long long int) weightLoadCost[r]*delta);
		delta=mac[m2].use[r]-mac[m1].sfc[r];
		if (delta>0) newlc+=((long long int) weightLoadCost[r]*delta);
		}
	for (r=0;r<nb_bo;r++)
		{
		r1=bao[r].res1;
		r2=bao[r].res2;
		delta=bao[r].target*(mac[m1].cap[r1]-mac[m2].use[r1]);
		delta=delta-        (mac[m1].cap[r2]-mac[m2].use[r2]);
		if (delta>0)
			newlc+=(bao[r].weight*delta);
		delta=bao[r].target*(mac[m2].cap[r1]-mac[m1].use[r1]);
		delta=delta-        (mac[m2].cap[r2]-mac[m1].use[r2]);
		if (delta>0)
			newlc+=(bao[r].weight*delta);
		}
	delta=newlc-(cur_lc[m1]+cur_lc[m2]);
	for (p=0;p<nb_pr;p++)
		{
		m=x[p];
		m0=x0[p];
		if (m==m1) 
			{
			if (m0==m2) 
				delta=delta-(MMC[m0][m1]+pro[p].movecost);
			else
			if (m0==m1) 
				delta=delta+(MMC[m0][m2]+pro[p].movecost);
			}
		else
		if (m==m2)
			{
			if (m0==m1) 
				delta=delta-(MMC[m0][m2]+pro[p].movecost);
			else
			if (m0==m2) 
				delta=delta+(MMC[m0][m1]+pro[p].movecost);
			}
		}
	return 1;
	}
void MatchingDescent::initcompatible(void)
	{
	short m,n;	
	nb_compatible=0;
	if (nb_rsTr!=0) return;
	for (m=0;m<nb_mc-1;m++)
		for (n=m+1;n<nb_mc;n++)
			if (mac[m].nei==mac[n].nei && mac[m].loc==mac[n].loc) 
				nb_compatible++;
	mc1=new short [nb_compatible];
	mc2=new short [nb_compatible];
	nb_compatible=0;
	for (m=0;m<nb_mc-1;m++)
		for (n=m+1;n<nb_mc;n++)
			if (mac[m].nei==mac[n].nei && mac[m].loc==mac[n].loc) 
				{
				mc1[nb_compatible]=m;
				mc2[nb_compatible]=n;
				nb_compatible++;
				}
	}


int MatchingDescent::descente(int cpulimit,int &cpu)
	{				
	long long int sl,sl_;
	long long int lcp,lcq,delta1,delta,lc1,lc2;
	int p,q,sp,na;
	short mp,m0p,m0q,mq,m,n,neip,locp,nmwmm;	
	char no_spread;
	nmwmm=0;
	do {
		na=0; // NUMBER OF CANDIDATE EDGES
		for (m=0;m<nb_mc;m++)
			{
			deg[m]=0;
			gswap[m][m]=0;
			for (n=m+1;n<nb_mc;n++) 
				{
				gswap[m][n]=gswap[n][m]=0;
				mark[m][n]=mark[n][m]=0;
				}
			}
		if (nb_rsTr==0)
			{
			// Compatible Machines Swap Evaluation
			for (m=0;m<nb_compatible;m++)
				{
				mp=mc1[m];
				mq=mc2[m];
				if (cur_lc[mp]!=0 || cur_lc[mq]!=0) // ONLY IF WORTH's IT
					{
					if (evalswapM1M2(mp,mq,delta)!=0)
						{
						if (delta<gswap[mp][mq]) 
							{
							gswap[mp][mq]=gswap[mq][mp]=delta;
							pqswap[mp][mq]=pqswap[mq][mp]=-1;
							na++;
							}
						}
					}
				}
			}
		// Processus Shift Evaluation
		if (na==0) // OTHERWISE IT IS TOO CPU TIME EXPENSIVE
			{
			for (p=0;p<nb_pr;p++)
				{
				mp=x[p];
				m0p=x0[p];
				evalsuppPM(p,mp,lc1);
				delta1=(lc1-cur_lc[mp]);
				sp=pro[p].numservice;	
				neip=mac[mp].nei;
				locp=mac[mp].loc;	
				no_spread=(ser[sp].spreadMin<2)?1:0;
				if (mp!=m0p) delta1-=MMC[m0p][mp];
				for (m=0;m<nb_mc;m++)
					if (m!=mp && (delta1<0 || cur_lc[m]>0) && sermac[sp][m]==0 && (pro[p].indep || (mac[m].nei==neip && (no_spread || mac[m].loc==locp))))
						{
						if (m!=m0p) 
							{
							if (load_PM(p,m,lc2)!=0)
								{
								delta=delta1+(lc2-cur_lc[m])+MMC[m0p][m];
								if (mp==m0p) 
									delta+=pro[p].movecost;
								if (delta<gswap[mp][m]) 
									{
									gswap[mp][m]=gswap[m][mp]=delta;
									pqswap[mp][m]=p;pqswap[m][mp]=p;
									na++;
									}
								}
							}
						else
							{
							if (load_PM0(p,m,lc2)!=0)
								{				
								delta=delta1+(lc2-cur_lc[m])-pro[p].movecost;
								if (delta<gswap[mp][m]) 
									{
									gswap[mp][m]=gswap[m][mp]=delta;
									pqswap[mp][m]=p;pqswap[m][mp]=p;
									na++;
									}
								}
							}
						}
				}
			}
		// Compatible Processus Swap Evaluation
		if (na==0) // OTHERWISE IT IS TOO CPU TIME EXPENSIVE
			{
			for (p=0;p<nb_pr-1;p++)
				{
				mp=x[p];
				sp=pro[p].numservice;
				mp=x[p];
				m0p=x0[p];
				suppPM_(p,mp);			// enlever p de mp
				for (q=p+1;q<nb_pr;q++)
					if (pro[q].numservice==sp  || (pro[p].indep && pro[q].indep))
						{
						mq=x[q];
						if (mq!=mp && (cur_lc[mp]>0 || cur_lc[mq]>0)) 
							{
							m0q=x0[q]; 
							if (mp!=m0q)
								{
								if (load_PM(q,mp,lcq)!=0)	// evaluer q sur mp
									{
									delta1=(lcq-cur_lc[mp])+MMC[m0q][mp]+pro[q].movecost;										
									suppPM_(q,mq);			// enlever q de mq
									if (mq!=m0p) 
										{
										if (load_PM(p,mq,lcp)!=0) // evaluer p sur mq
											{
											delta=delta1+(lcp-cur_lc[mq])+MMC[m0p][mq]+pro[p].movecost;
											if (delta<gswap[mp][mq]) 
												{
												gswap[mp][mq]=gswap[mq][mp]=delta;
												pqswap[mp][mq]=p;pqswap[mq][mp]=q;
												na++;
												}
											}
										}
									else
										{
										if (load_PM0(p,mq,lcp)!=0) // evaluer p sur mq=m0p
											{
											delta=delta1+(lcp-cur_lc[mq]);
											if (delta<gswap[mp][mq]) 
												{
												gswap[mp][mq]=gswap[mq][mp]=delta;
												pqswap[mp][mq]=p;pqswap[mq][mp]=q;
												na++;
												}
											}
										}
									addPM_(q,mq); // replacer q sur mq
									}
								}
							else
								{
								if (load_PM0(q,mp,lcq)!=0) // evaluer q sur mp=m0q
									{
									suppPM_(q,mq);			// enlever q de mq
									delta1=lcq-cur_lc[mp];
									if (mq!=m0p)
										{
										if (load_PM(p,mq,lcp)!=0) // evaluer p sur mq
											{
											delta=delta1+(lcp-cur_lc[mq])+MMC[m0p][mq]+pro[p].movecost;
											if (delta<gswap[mp][mq]) 
												{
												gswap[mp][mq]=gswap[mq][mp]=delta;
												pqswap[mp][mq]=p;pqswap[mq][mp]=q;
												na++;
												}
											}
										}
									else
										{
										if (load_PM0(p,mq,lcp)!=0) // evaluer p sur mq=m0p
											{
											delta=delta1+lcp-cur_lc[mq];
											if (delta<gswap[mp][mq]) 
												{
												gswap[mp][mq]=gswap[mq][mp]=delta;
												pqswap[mp][mq]=p;pqswap[mq][mp]=q;
												na++;
												}
											}
										}
									addPM_(q,mq); // replacer q sur mq
									}
								}	
							}	
						}
				addPM_(p,mp);      // replacer p sur mp		
				cpu=clock()/CLOCKS_PER_SEC;
				if (cpu>cpulimit-10) break;
				}
			}
		if (na!=0) 
			{
			int nm;
			short m0z,m_;
			char encore;
			for (mp=0;mp<nb_mc-1;mp++)
				for (mq=mp+1;mq<nb_mc;mq++)
					if (gswap[mp][mq]<0)
						{
						deg[mp]++;
						deg[mq]++;
						mark[mq][mp]=mark[mp][mq]=1;
						}
			sl_=sl=sum_move+sum_load;
			m0z=rand3()%nb_mc;
			do {
	// choix aleatoire d'une machine  RANDOM CHOICE OF THE FIRST NODE
				encore=1;
				for (m=m0z;m<nb_mc;m++)
					if (deg[m]!=0) break;	
				if (m>=nb_mc)
					{
					for (m=0;m<m0z;m++)
						if (deg[m]!=0) break;
					if (m>=m0z) 
						encore=0;
					}
				if (encore)
					{
	// construction d'un chemin de swaps qui passe par m ::: BUILDING THE PATH (OR CIRCUIT) FROM THE FIRST NODE
					nba=0; // NUMBER OF EDGES
					do {	
						// choix du swap de poids minimal
						for (nm=0;nm<nb_mc;nm++)
							if (nm!=m && mark[m][nm]!=0) break;
						if (nm>=nb_mc) {printf("bug pathbuilding %d",nba);exit(0);}
						for (n=nm+1;n<nb_mc;n++)
							if (n!=m && mark[m][n]!=0 && gswap[m][n]<gswap[m][nm]) nm=n;
						machine1[nba]=m;
						machine2[nba++]=nm;
						if (nba>=nb_mc) {printf("bug pathbuilding %d",nba);exit(0);}
						// suppression des swaps impliquant m	
						for (n=0;n<m;n++)
							if (mark[m][n]!=0) {mark[m][n]=mark[n][m]=0;deg[n]--;}
						for (n=m+1;n<nb_mc;n++)
							if (mark[m][n]!=0) {mark[m][n]=mark[n][m]=0;deg[n]--;}
						deg[m]=0;
						m=nm;
						} 
					while (deg[m]!=0);
					if (nba==0) {puts("bug nba");exit(0);}
					MWM();  // USE DYNAMIC PROGRAMING FOR COMPUTE THE MaxWeightMatch ON THIS PATH (OR CIRCUIT)
					m=match[nba];
					while (m>0)
						{
						nmwmm++;
						if (m==match[m])
							{					
							mp=machine1[m-1];
							mq=machine2[m-1];	
							sl=sl+gswap[mp][mq];					
							p=pqswap[mp][mq];					
							q=pqswap[mq][mp];
							if (p!=q)
								{
								n2++;
								mp=x[p];
								mq=x[q];
								suppPM(p,mp);
								suppPM(q,mq);
								addPM(p,mq);
								addPM(q,mp);
								loadCostMachine(mp,lcp);
								sum_load=sum_load+lcp-cur_lc[mp];
								cur_lc[mp]=lcp;
								loadCostMachine(mq,lcq);
								sum_load=sum_load+lcq-cur_lc[mq];
								cur_lc[mq]=lcq;
								x[p]=mq;
								x[q]=mp;
								}
							else
							if (p>=0)
								{
								n1++;
								mp=x[p];
								mq=machine1[m-1]; 
								if (mp==mq) mq=machine2[m-1];
								suppPM(p,mp);
								addPM(p,mq);
								loadCostMachine(mp,lcp);
								sum_load=sum_load+lcp-cur_lc[mp];
								cur_lc[mp]=lcp;
								loadCostMachine(mq,lcq);
								sum_load=sum_load+lcq-cur_lc[mq];
								cur_lc[mq]=lcq;
								x[p]=mq;
								}
							else
								{
								mp=machine1[m-1];
								mq=machine2[m-1]; 
								for (p=0;p<nb_pr;p++)
									{
									m_=x[p];
									if (m_==mp)
										{
										n3++;
										suppPM(p,mp);
										addPM(p,mq);
										x[p]=mq;
										}
									else
									if (m_==mq)
										{
										n3++;
										suppPM(p,mq);
										addPM(p,mp);
										x[p]=mp;
										}
									}
								loadCostMachine(mp,lcp);
								sum_load=sum_load+lcp-cur_lc[mp];
								cur_lc[mp]=lcp;
								loadCostMachine(mq,lcq);
								sum_load=sum_load+lcq-cur_lc[mq];
								cur_lc[mq]=lcq;
								}
							m=m-2;
							}
						else
							m=match[m];
						}
					}
				}  
			while (encore);
			sl=sum_move+sum_load;
			}
		cpu=clock()/CLOCKS_PER_SEC;
		}
	while (na!=0 && cpu<cpulimit);
#if !SILENT
  printf("\nMWM %d %5d PSHIFT %5d PSWAP %5d MSWAP : COST %I64d\n",nmwmm,n1,n2,n3,sum_load+sum_move);
#endif
	return nmwmm;
	}



void MatchingDescent::loadCostMachine(short m,long long int &lc)
	{
	long long int delta;
	short r,r1,r2;
	lc=0;
	for (r=0;r<nb_rs;r++)
		{
		delta=mac[m].use[r]-mac[m].sfc[r];
		if (delta>0) 
			lc=lc+((long long int) weightLoadCost[r]*delta);
		}
	for (r=0;r<nb_bo;r++)
		{
		r1=bao[r].res1;
		r2=bao[r].res2;
		delta=bao[r].target*(mac[m].cap[r1]-mac[m].use[r1]);
		delta=delta-(mac[m].cap[r2]-mac[m].use[r2]);
		if (delta>0)
			lc=lc+(bao[r].weight*delta);
		}
	}



void MatchingDescent::algo(void)
	{	
	int cpu;
	initcompatible();
	descente(cpulimit,cpu); 
}
void MatchingDescent::firstinit(void)
	{
	long long int load;
	int p,m;
	service_move_max=0;
	nb_service_move_max=nb_sr;
	cur_lc=new long long int [nb_mc];
	sum_move=sum_load=0;
	for (m=0;m<nb_mc;m++)
		{
		loadCostMachine(m,load);
		cur_lc[m]=load;
		sum_load=sum_load+load;
		for (p=0;p<nb_mc;p++)
			{
			if (p!=m)
				MMC[m][p]=weightMMCost*MMC[m][p];
			}
		}
	upper_bound=sum_load;
}



void MatchingDescent::solve(const char *modelFileName, const char *assignmentFileName, int cpulimit_)
{
  if (litjeu(modelFileName)!=0) return;
  if (litsolinit(assignmentFileName)!=0) return;
	srand3(3); 
  cpulimit = cpulimit_;
	firstinit();
#if REPORT
	printf("\nUpper Bound %I64d cpu %d sec",upper_bound,clock()/CLOCKS_PER_SEC);
#endif
  algo();
}
